;;; DO NOT MODIFY THIS FILE
(if (featurep 'jde-autoloads) (error "Already loaded"))

;;;### (autoloads nil "_pkg" "lisp/_pkg.el")

(package-provide 'jde :version 1.27 :type 'regular)

;;;***

;;;### (autoloads (jde-bug-debug-app) "jde-bug" "lisp/jde-bug.el")

(autoload 'jde-bug-debug-app "jde-bug" "\
Runs the debugger on the application in the current source buffer." t nil)

;;;***

;;;### (autoloads (jde-compile jde-set-compile-options) "jde-compile" "lisp/jde-compile.el")

(autoload 'jde-set-compile-options "jde-compile" "\
Sets the compile options.
Enter the options as you would on the command line, e.g.,
-depend -verbose." t nil)

(autoload 'jde-compile "jde-compile" "\
Compile the Java program in the current buffer.
This command invokes the compiler specified by `jde-compiler'
with the options specified by the JDE customization variables
that begin with `jde-compile'. If the variable
`jde-read-compile-args' is non-nil, this command reads
additional compilation options from the minibuffer, with
history enabled." t nil)

;;;***

;;;### (autoloads (jde-db-applet jde-db jde-db-set-app-args jde-db-set-args jde-db-set-debugger) "jde-db" "lisp/jde-db.el")

(autoload 'jde-db-set-debugger "jde-db" "\
Specify the pathname of the debugger, if an executable, or the
debugger's fully qualified class name, if a class." t nil)

(autoload 'jde-db-set-args "jde-db" "\
Specify the arguments (except -classpath) to be passed to the debugger." t nil)

(autoload 'jde-db-set-app-args "jde-db" "\
Specify the arguments to be passed to the Java application class." t nil)

(autoload 'jde-db "jde-db" "\
Run jdb on Java application whose source resides in the current buffer.
This command determines the main class of the application either from
the variable `jde-run-application-class' or from the source in the current 
buffer. If `jde-run-application-class' does not specify a class, the main class
is assumed to be the class defined by the current source buffer. This command
creates a command buffer named *gud-CLASS* for the debug session.
CLASS is the name of the class you are debugging." t nil)

(autoload 'jde-db-applet "jde-db" "\
Runs an applet in the debugger. This function prompts you to enter
the path of an html document that displays the applet. If you 
do not enter a path, this function next checks
whether `jde-run-applet-doc' specifies a document. If so, it displays
that specified document. Next, it checks whether the current directory
contains any html files. If so, it displays the first html file that
it finds. If if cannot find an html file, it signals an error.  This
function runs appletviewer in jdb to permit debugging. On startup, it
sets a breakpoint in the init method of the class specified by 
`jde-run-application-class' or in the class corresponding to the Java
file in the current buffer." t nil)

;;;***

;;;### (autoloads (jde-gen-buffer jde-gen-jfc-app-buffer jde-gen-console-buffer jde-gen-class-buffer) "jde-gen" "lisp/jde-gen.el")

(autoload 'jde-gen-class-buffer "jde-gen" "\
Create a new Java buffer containing a class of the same name.
This command inserts the class template generated by `jde-gen-class'.
It then moves the point to the location to the constructor." t nil)

(autoload 'jde-gen-console-buffer "jde-gen" "\
Create a new Java buffer containing a console class of the same name.
This command inserts the class template generated by `jde-gen-class'.
It then moves the point to the location to the constructor." t nil)

(autoload 'jde-gen-jfc-app-buffer "jde-gen" "\
Create a new Java buffer containing a JFC application class.
This command inserts the class template generated by `jde-gen-jfc-app'.
It then moves the point to the location to the constructor." t nil)

(autoload 'jde-gen-buffer "jde-gen" "\
Create a new Java buffer containing a code template.
This command inserts the specified template at the beginning
of the buffer." t nil)

;;;***

;;;### (autoloads (jde-import-organize) "jde-import" "lisp/jde-import.el")

(autoload 'jde-import-organize "jde-import" "\
Organize import statements of the current Java source buffer.
If optional FORCE is non-nil force reordering even if imports are
already organized.

Imports are organized into groups returned by the function specified
by `jde-import-group-function'.  Groups are inserted in the order they
are found unless `jde-import-sorted-groups' requires that they must be
alphabetically sorted.  In each group imports are sorted by name
alphabetically or in reverse order if `jde-import-reverse-sort-group'
is non-nil.  A blank line is inserted between groups.

Usage:
  \\[jde-import-organize] group and sort import statements.
  \\[universal-argument] \\[jde-import-organize] to force reordering.

The current buffer must be in `jde-mode'.  This command requires a
version of the JDE with the semantic parser." t nil)

;;;***

;;;### (autoloads (jde-java-font-lock-setup-keywords) "jde-java-font-lock" "lisp/jde-java-font-lock.el")

(autoload 'jde-java-font-lock-setup-keywords "jde-java-font-lock" "\
Setup font lock keywords in `java-font-lock-keywords-4'.
If optional REBUILD flag is non-nil create a new cache of regular
expressions." t nil)

;;;***

;;;### (autoloads (jde-javadoc-make) "jde-javadoc-gen" "lisp/jde-javadoc-gen.el")

(autoload 'jde-javadoc-make "jde-javadoc-gen" "\
Generates javadoc for the current project. This command runs the
JDE javadoc program to generate the documentation. The variable
`jde-javadoc-command-path' specifies the path of the javadoc excutable.
The variable `jde-global-classpath' specifies the javadoc 
-classpath argument. The variable `jde-db-source-directories'
specifies the javadoc  -sourcepath argument. You can specify all
other javadoc options via JDE customization variables. To specify the
options, select Project->Options->Javadoc from the JDE menu. Use 
`jde-javadoc-gen-packages' to specify the packages, classes, or source
files for which you want to generate javadoc. If this variable is nil,
this command generates javadoc for the Java source file in the current
buffer. If `jde-javadoc-display-doc' is nonnil, this command displays
the generated documentation in a browser." t nil)

;;;***

;;;### (autoloads (jde-javadoc-checkdoc jde-javadoc-checkdoc-at-line jde-javadoc-autodoc-at-line jde-javadoc-customize) "jde-javadoc" "lisp/jde-javadoc.el")

(autoload 'jde-javadoc-customize "jde-javadoc" "\
Show the jde-javadoc options panel." t nil)

(autoload 'jde-javadoc-autodoc-at-line "jde-javadoc" "\
Update javadoc comment block for declaration at current line.

Uses the semantic bovinator parser table to find declarations (see
`jde-javadoc-nonterminal-at-line').

BEFORE EXECUTING THE COMMAND, THE POINT MUST BE LOCATED AT THE FIRST
LINE OF THE CLASS OR METHOD DECLARATION.  IF NOT RESULT IS UNCERTAIN.

In the following examples, point is located at the beginning of the
line, before the word 'public' (but it could be anywhere on this
line):

1- Class example:
   -------------

-|-  public class MyClass
       extends MySuperClass implements Runnable, java.io.Serializable
     {
       ...

\\[jde-javadoc-autodoc-at-line] inserts:

+    /**
+     * Describe class <code>MyClass</code> here.
+     *
+     * @author \"David Ponce\" <david.ponce@wanadoo.fr>
+     * @version 1.0
+     * @since 1.0
+     * @see MySuperClass
+     * @see Runnable
+     * @see java.io.Serializable
+     */
     public class MyClass
       extends MySuperClass implements Runnable, java.io.Serializable
     {
       ...

2- Method example:
   --------------

-|-  public
     void   myMethod( int  x,  int y )
       throws Exception
     {
       ...

\\[jde-javadoc-autodoc-at-line] inserts:

+    /**
+     * Describe <code>myMethod</code> method here.
+     *
+     * @param x an <code>int</code> value
+     * @param y a <code>long</code> value
+     * @exception Exception if an error occurs
+     */
     public
     void   myMethod( int  x,  long y )
       throws Exception
     {
       ...

3- Field example:
   --------------

-|-  private static final int SIZE = 10;

\\[jde-javadoc-autodoc-at-line] inserts:

+    /**
+     * Describe constant <code>SIZE</code> here.
+     */
     private static final int SIZE = 10;


`tempo' templates are used for each category of javadoc line.  The
following templates are currently defined and fully customizable (see
`tempo-define-template' for the different items that can be used in a
tempo template):

- - `jde-javadoc-author-tag-template'
- - `jde-javadoc-describe-class-template'
- - `jde-javadoc-describe-constructor-template'
- - `jde-javadoc-describe-interface-template'
- - `jde-javadoc-describe-method-template'
- - `jde-javadoc-describe-field-template'
- - `jde-javadoc-exception-tag-template'
- - `jde-javadoc-param-tag-template'
- - `jde-javadoc-return-tag-template'
- - `jde-javadoc-see-tag-template'
- - `jde-javadoc-since-tag-template'
- - `jde-javadoc-version-tag-template'

For example if you customize `jde-javadoc-describe-class-template'
with the following value:

'(\"* \" (P \"Class description: \"))

you will be asked to enter the class description in the minibuffer.
See also the `jde-javadoc-field-type', `jde-javadoc-a' and
`jde-javadoc-code' helper functions." t nil)

(autoload 'jde-javadoc-checkdoc-at-line "jde-javadoc" "\
Check javadoc comment block of declaration at current line.

Uses the semantic bovinator parser table to find declarations (see
`jde-javadoc-nonterminal-at-line').

BEFORE EXECUTING THE COMMAND, THE POINT MUST BE LOCATED AT THE FIRST
LINE OF THE CLASS OR METHOD DECLARATION.  IF NOT RESULT IS UNCERTAIN." t nil)

(autoload 'jde-javadoc-checkdoc "jde-javadoc" "\
Check doc comments of tokens in the current buffer.
Report the next token with documentation errors." t nil)

;;;***

;;;### (autoloads (jde-make) "jde-make" "lisp/jde-make.el")

(autoload 'jde-make "jde-make" "\
Run the JDE make program." t nil)

;;;***

;;;### (autoloads (jde-package-update jde-package-generate-package-statement jde-package-customize) "jde-package" "lisp/jde-package.el")

(autoload 'jde-package-customize "jde-package" "\
Customization of the group jde-package." t nil)

(autoload 'jde-package-generate-package-statement "jde-package" "\
Generates a Java package statement. If the package name cant be generated
this function returns an empty string." nil nil)

(autoload 'jde-package-update "jde-package" "\
Updates or replaces the Java package statement in the current buffer.
If the package statement does not exist a new one is inserted at the
top of the buffer. If the package name cant be generated nothing is done.
The major mode of current buffer must be 'jde-mode'." t nil)

;;;***

;;;### (autoloads (jde-run-applet jde-run-mode jde-run jde-run-set-applet-doc jde-run-set-applet-viewer jde-run-set-app-args jde-run-set-args jde-run-set-app jde-run-set-vm-w jde-run-set-vm) "jde-run" "lisp/jde-run.el")

(autoload 'jde-run-set-vm "jde-run" "\
Specifies the Java interpreter used to run Java applications
on non-Windows platforms . The default is java." t nil)

(autoload 'jde-run-set-vm-w "jde-run" "\
Specifies the Java interpreter used to run Java applications
on Windows platforms . The default is javaw." t nil)

(autoload 'jde-run-set-app "jde-run" "\
Specify the name of the application class to run." t nil)

(autoload 'jde-run-set-args "jde-run" "\
Specify arguments to be passed to the Java vm.
This command serves as an alternative to using the JDE Run Options
panel to specify command-line arguments for the Java interpreter." t nil)

(autoload 'jde-run-set-app-args "jde-run" "\
Specify the arguments to be passed to the Java application class.
This command provides an alternative to using the JDE Run Options panel
to specify command-line arguments to pass to the application when starting
the application." t nil)

(autoload 'jde-run-set-applet-viewer "jde-run" "\
Sets the viewer to be used to view an applet. The default is 
appletviewer." t nil)

(autoload 'jde-run-set-applet-doc "jde-run" "\
Specify the doc to be used to view an applet.
This command provides an alternative to using the JDE Options
panel to specifying the applet document." t nil)

(autoload 'jde-run "jde-run" "\
Run the Java application specified by `jde-run-executable', if
not the null string. Otherwise run the class specified by 
`jde-run-application-class', if non-null; otherwise the class in
the current buffer. This command also creates a comint buffer to allow
you to interacti with the program." t nil)

(autoload 'jde-run-mode "jde-run" "\
Mode for running Java programs." t nil)

(autoload 'jde-run-applet "jde-run" "\
Runs an applet. This function prompts you to enter the path of an
html document that displays the applet. If you enter return without
specifying a document, this function next checks whether
`jde-run-applet-doc' specifies a document. If so, it displays that
specified document. Next, it checks whether the current directory
contains any html files. If the current directory contains an html
file with the same root name as the Java file in the current buffer,
it displays the file. If not, it displays the first html file that it
finds in the current directory. If if cannot find an html file, it
signals an error.  This function uses the viewer specified by
`jde-run-applet-viewer' to display the specified document. Note that
if you run two html applet files successively with the same name, you
must kill the buffer created to run the first file before running the
second file. Otherwise, this command will simply redisplay the first
file." t nil)

;;;***

;;;### (autoloads nil "jde-which-method" "lisp/jde-which-method.el")

(defcustom jde-which-method-mode t "Enables the JDE's which method mode.\nWhen which method mode is enabled, the current method name is\ndisplayed in the mode line." :group 'jde-which-method :type 'boolean)

;;;***

;;;### (autoloads (jde-compile-jde jde-show-help jde-save-project jde-open-project-file jde-mode jde-build jde-java-build jde-browse-jdk-doc jde-set-global-classpath jde-set-compiler) "jde" "lisp/jde.el")

(defconst jde-version "2.2.7beta3" "\
JDE version number.")

(autoload 'jde-set-compiler "jde" "\
Specify the pathname of the compiler to be used to compile the
current buffer. Default is javac." t nil)

(autoload 'jde-set-global-classpath "jde" "\
Specify the value of the -classpath argument for the Java compiler and
interpreter." t nil)

(autoload 'jde-browse-jdk-doc "jde" "\
Displays the JDK doc in a web browser. This function uses the URL
stored in the variable jde-jdk-doc-url to locate the JDK documentation." t nil)

(autoload 'jde-java-build "jde" "\
Use javac -depend to build the application whose main class is
specified by `jde-run-application-class'." t nil)

(autoload 'jde-build "jde" "\
Rebuild the entire project.
This command has two operating modes: java and make. In java mode,
this command uses javac's built-in make facility to rebuild a
project. In make mode, this command uses a user-specified make program
to rebuild the project. JDE configuration variables control which mode
is used.  In particular, if the variable `jde-build-use-make' is
non-nil, this command invokes the make program specified by the
variable `jde-make-program'. If the variable `jde-make-args' is a
non-empty string, this function uses its contents to invoke make;
otherwise, it prompts you to enter command-line arguments for make. If
`jde-build-use-make' is nil, this function invokes javac on the source
file specified by `jde-run-app-class', with the -depend option. This
causes javac to recompile all missing or out-of-date files required
to run the application's main class." t nil)

(autoload 'jde-mode "jde" "\
Major mode for developing Java applications and applets." nil nil)

(setq auto-mode-alist (append '(("\\.java\\'" . jde-mode)) auto-mode-alist))

(autoload 'jde-open-project-file "jde" "\
Opens the project file for the Java source file in the
current buffer." t nil)

(autoload 'jde-save-project "jde" "\
Saves local source file buffer options in project file.
This command provides an easy way to create and update a
project file for a Java project. Simply open a source file,
set the desired options, using the JDE Options menu, then
save the settings in the project file, using this command.
Now, whenever you open a source file from the same directory
tree, the saved settings will be restored for that file." t nil)

(autoload 'jde-show-help "jde" "\
Displays the JDE User's Guide in a browser." t nil)

(autoload 'jde-compile-jde "jde" "\
Byte-compile all uncompiled files of jde." t nil)

;;;***

(provide 'jde-autoloads)
